#!/bin/bash

HATELIST="/glftpd/tmp/hate.list" # Full path. Not chrooted.
DATAPATH="/glftpd/ftp-data" # Full path. Not chrooted.
LOGFILE="/glftpd/ftp-data/logs/glftpd.log" # Full path to glftpd.log
BACKUP="/glftpd/ftp-data/users/backup" # Backup path. Make sure to create it.
VERBOSE="1"
bonus="1000000"

[ -f "$HATELIST" ] || {
    echo "Error: Rape list file '$HATELIST' nonexistent." 1>&2
    exit 1
}

[ -d "$DATAPATH" ] || {
    echo "Error: Invalid DATAPATH '$DATAPATH'." 1>&2
    exit 1
}

cut -f2 -d: "$HATELIST" | sort | uniq -c | sort -rn | {
    read count user || exit
    [ -f "$DATAPATH/users/$user" ] || {
        [ "$VERBOSE" = "1" ] && 
            echo "User with most hates, '$user' does not seem to exist." 1>&2
        exit 1
    }
    [ -w "$DATAPATH/users" ] || {
        [ "$VERBOSE" = "1" ] && 
            echo "Error: $DATAPATH/users is not writable!" 1>&2
        exit 1
    }
    mv -f "$DATAPATH/users/$user" "$BACKUP/$user.old"
    curcreds="$(cat $BACKUP/$user.old | grep CREDITS | awk -F" " '{print $2}')"
    aftercreds="$(expr $curcreds - $bonus)"
    sed -e "8,8 s/$curcreds/$aftercreds/" $BACKUP/$user.old > $DATAPATH/users/$user    

    echo $(date +'%a %b %d %T %Y') LOVEHATE: \"Most hated user this week was $user. 1Gb creds removed!\" >> "$LOGFILE"
    echo "Took $bonus creds to '$user' for being so hated."
}

> "$HATELIST"

exit 0
